(**$Revision: 1.4.7.1 $**)
UNIT KRDialog;
INTERFACE
USES
    Classes,os2def,os2base,os2pmapi,SysUtils,VPUtils,
    NuCell,xmlRead,xmlWrite,dom,KrUnit;

{$I krm.inc}
{$H+}
(* Local procedures *)

TYPE
    PageConfDataRecord=RECORD
        pChPageName:pChar;
        pChPageInfo:pChar;
        AppName:String;
        hptrIcon:hPointer;
        ColumAttr:ColumToSuffixArray;
    END;
    RecordConfDataRecord=RECORD
        hptrIcon:HPointer;
        pChAry:ARRAY[1..MaxColumList] OF pChar;
        isExpireCheck:BOOLEAN;
    END;
    PassConfDataRecord=RECORD
        Password:string;
        isUse:BOOLEAN;
    END;
    SettingConfRecord=RECORD
        pBackupPath:pChar;
        isUseBackupPath:BOOL;
        BackupGen:INTEGER;
    END;
    pRecordConfDataRecord   =^RecordConfDataRecord;
    pPageConfDataRecord     =^PageConfDataRecord;

FUNCTION PasswordDlgProc( hwndDlg: HWND ;
                            ulMsg  : ULONG;
                            mp1    : MPARAM;
                            mp2    : MPARAM ) : mResult; cdecl;

FUNCTION RecordConfDlgProc( hwndDlg: HWND ;
                            ulMsg  : ULONG;
                            mp1    : MPARAM;
                            mp2    : MPARAM ) : mResult; cdecl;
    

FUNCTION PageConfDlgProc( hwndDlg: HWND ;
                          ulMsg  : ULONG;
                          mp1    : MPARAM;
                          mp2    : MPARAM ) : mResult; cdecl;

FUNCTION SettingConfProc( hwndDlg: HWND ;
                          ulMsg  : ULONG;
                          mp1    : MPARAM;
                          mp2    : MPARAM ) : mResult; cdecl;


PROCEDURE PageConfManegeProc(window:hwnd);

PROCEDURE RecordConfManegeProc(window:hwnd);



VAR
    PageConfData:PageConfDataRecord;
    RecConfData:RecordConfDataRecord;
    PassConfData:PassConfDataRecord;
    SettingConfData:SettingConfRecord;
    EntrySt:String;

IMPLEMENTATION
VAR

    pCh:pChar;
VAR
    OldDropPermitProc:FNWP;
    
    
FUNCTION DMDrop(Window:HWnd;MP1,MP2:MParam):string;
    PROCEDURE fileFromDragItem( pdiItem : PDRAGITEM; pchFile : PCHAR );
    VAR
      achPath : ARRAY[0..CCHMAXPATH-1] OF CHAR;
      achFile : ARRAY[0..CCHMAXPATH-1] OF CHAR;
    BEGIN
       DrgQueryStrName(pdiItem^.hstrContainerName,
                       sizeof(achPath),
                       achPath);
       DosQueryPathInfo(achPath,
                        FIL_QUERYFULLNAME,
                        achPath,
                        sizeof(achPath));

       IF (achPath[strlen(achPath)-1] <> '\') THEN strcat(achPath, '\');
       DrgQueryStrName(pdiItem^.hstrSourceName,sizeof(achFile),achFile);
       pchFile:=strcopy( pchFile, achPath );
       strcat( pchFile, achFile );
    END;

VAR
    pdiDrag : PDRAGINFO;
    DropStr : String;
    pdiItem : PDRAGITEM;
    achFullFile : ARRAY[0..CCHMAXPATH-1] OF CHAR;
    pCh:pChar;
BEGIN
    pdiDrag := PVOIDFROMMP(mp1);
    DrgAccessDraginfo( pdiDrag^ );

    pdiItem := DrgQueryDragitemPtr(pdiDrag^, 0);
    fileFromDragItem(pdiItem, achFullFile);

    DMDrop:=StrPas(@achFullFile[0]);

    WinSendMsg( pdiDrag^.hwndSource,
                DM_ENDCONVERSATION,
                MPFROMLONG(pdiItem^.ulItemID),
                MPFROMLONG(DMFL_TARGETSUCCESSFUL) );

    DrgFreeDraginfo(pdiDrag^);
END;

FUNCTION PageDropPermitProc( hwndAny : HWnd;
                          ulMsg     : ULong;
                          mpParm1   : MParam;
                          mpParm2   : MParam ) : mResult; cdecl;
VAR
    hptrIcon:hPointer;
    st:string;
BEGIN
    IF ulMsg=DM_DRAGOVER THEN BEGIN
        result:=MRFROM2SHORT(DOR_DROP, DO_MOVE);
    END
    ELSE IF ulMsg=DM_Drop THEN BEGIN
        st:=DMDrop(hwndAny,mpParm1,mpParm2);
        st:=st+#0;
        hptrIcon:=WinLoadFileIcon(@st[1],FALSE);
        IF hptrIcon<>NullHandle THEN BEGIN
            WinSendMsg( hwndAny,
                        SM_SETHANDLE,
                        WinLoadPointer( HWND_DESKTOP,
                                        NULLHANDLE,
                                        ICO_BLANK),
                        0);
            WinSendMsg( hwndAny,
                        SM_SETHANDLE,
                        hptrIcon,
                        0);
            System.Delete(st,length(st),1);
            PageConfData.AppName:=St;
        END;
    END
    ELSE
        result:=OldDropPermitProc(hwndAny,ulMsg,mpParm1,mpParm2);
END;

FUNCTION DropPermitProc( hwndAny : HWnd;
                          ulMsg     : ULong;
                          mpParm1   : MParam;
                          mpParm2   : MParam ) : mResult; cdecl;
VAR
    hptrIcon:hPointer;
    st:string;
BEGIN
    IF ulMsg=DM_DRAGOVER THEN BEGIN
        result:=MRFROM2SHORT(DOR_DROP, DO_MOVE);
    END
    ELSE IF ulMsg=DM_Drop THEN BEGIN
        st:=DMDrop(hwndAny,mpParm1,mpParm2);
        RecConfData.pChAry[1]:=StrPCopy(RecConfData.pChAry[1],St);
        IF pChToHPointer(RecConfData.pChAry[1],hptrIcon) THEN BEGIN
            WinSendMsg( hwndAny,
                        SM_SETHANDLE,
                        WinLoadPointer( HWND_DESKTOP,
                                        NULLHANDLE,
                                        ICO_BLANK),
                        0);
            WinSendMsg( hwndAny,
                        SM_SETHANDLE,
                        hptrIcon,
                        0);
        END;
    END
    ELSE
        result:=OldDropPermitProc(hwndAny,ulMsg,mpParm1,mpParm2);
END;

FUNCTION Draw1Bitmap(hpsDraw : HPS;
                     hbmBitmap : HBITMAP;
                     prclDest : PRECTL ) : Bool;
VAR
  bmihHeader  : BITMAPINFOHEADER2;
  ptlPoint    : POINTL;
  bRc         : BOOL;

BEGIN
   bmihHeader.cbFix := 16;
   GpiQueryBitmapInfoHeader(hbmBitmap,
                            bmihHeader);

   {************************************************************}
   {* set the x and y coordinates                              *}
   {************************************************************}

   ptlPoint.x := (prclDest^.xRight-prclDest^.xLeft-bmihHeader.cx) div
      2+prclDest^.xLeft;

   ptlPoint.y := (prclDest^.yTop-prclDest^.yBottom-bmihHeader.cy) div
      2+prclDest^.yBottom;

   {************************************************************}
   {* draw the bitmap                                          *}
   {************************************************************}

   bRc := WinDrawBitmap(hpsDraw,
                       hbmBitmap,
                       NIL,
                       @ptlPoint,
                       0,
                       0,
                       DBM_NORMAL OR DBM_IMAGEATTRS);
   Draw1BitMap := bRc;
END;

VAR
    hwndPageName:hwnd;
    hwndPageInfo:hwnd;
    hwndAppStatic:hwnd;
    hwndColumList:hwnd;
    hwndUp,hwndDown,hwndShowHide:hwnd;
    AppSWP:SWP;
FUNCTION PageConfDlgProc( hwndDlg: HWND ;
                      ulMsg  : ULONG;
                      mp1    : MPARAM;
                      mp2    : MPARAM ) : mResult;
VAR
    pPageConf:pPageConfDataRecord;
    ptlDrop     : PointL;
    st:string;
    hptrIcon:HPointer;
    rc:bool;
    i,j,k:INTEGER;
    pChList:pChar;
    ps:hps;
    fmMetrics:FontMetrics;
    hbmBitmap:HBitmap;
    bmihHeader:bitmapInfoHeader2;
    poiItem     : POWNERITEM;
    rclText     : RECTL;
    Col1, Col2  : INTEGER;
BEGIN
    result:=0;
    CASE(ulMsg) OF
        WM_INITDLG:BEGIN
            hwndColumList:=WinWindowFromID(hwndDlg,DID_COLUMLIST);
            hwndUp:=WinWindowFromID(hwndDlg,DID_UP);
            hwndDown:=WinWindowFromID(hwndDlg,DID_DOWN);
            hwndShowHide:=WinWindowFromID(hwndDlg,DID_SHOWHIDE);

            hwndPageName:=WinWindowFromID(hwndDlg,DID_EDIT_CONTROL);
            hwndPageInfo:=WinWindowFromID(hwndDlg,DID_PAGEINFO);
           WinSendMsg(hwndPageName,EM_SETTEXTLIMIT,MaxCharLength-1,NullHandle);
           WinSendMsg(hwndPageInfo,EM_SETTEXTLIMIT,MaxCharLength-1,NullHandle);
            hwndAppStatic:=WinWindowFromID(hwndDlg,DID_APPSTATIC);
            @OldDropPermitProc:=WinSubClassWindow(hwndAppStatic,
                                                  PageDropPermitProc);
            WinQueryWindowPos(WinWindowFromID(hwndDlg,DID_AppGroup),AppSWP);
            pPageConf:=pPageConfDataRecord(mp2);

            WinSetWindowText(hwndPageName,pPageConf^.pChPageName);
            WinSetWindowText(hwndPageInfo,pPageConf^.pChPageInfo);
            WinSendMsg( hwndAppStatic,
                        SM_SETHANDLE,
                        pPageConf^.hptrIcon,
                        0);
            FOR i := 3 TO MaxColumList DO
               WinInsertLboxItem(hwndColumList,LIT_END,ColumList[i]);

            WinSendDlgItemMsg(hwndDlg,
                              DID_COLUMLIST,
                              LM_SELECTITEM,
                              MPFROMSHORT(0),
                              ord(TRUE));

        END;
        DM_DragOver:BEGIN
            ptlDrop.x := SHORT1FROMMP(mp2);
            ptlDrop.y := SHORT2FROMMP(mp2);

            WinMapWindowPoints(HWND_DESKTOP,
                               hwndDlg,
                               ptlDrop,
                               1);
           IF (ptlDrop.x>=AppSWP.x) AND (ptlDrop.x<=AppSWP.x+AppSWP.cx) AND
               (ptlDrop.y>=AppSWP.y) AND (ptlDrop.y<=AppSWP.y+AppSWP.cy)
            THEN
                result:=MRFROM2SHORT(DOR_DROP, DO_MOVE);
        END;
        DM_Drop:BEGIN
            St:=DMDrop(hwndDlg,mp1,mp2);
            PageConfData.AppName:=St;
            St:=St+#0;
            hptrIcon:=WinLoadFileIcon(@St[1],FALSE);
            IF hptrIcon<>NullHandle THEN BEGIN
                WinSendMsg( hwndAppStatic,
                            SM_SETHANDLE,
                            WinLoadPointer(HWND_DESKTOP,NULLHANDLE,ICO_BLANK),
                            0);
                WinSendMsg( hwndAppStatic,
                            SM_SETHANDLE,
                            hptrIcon,
                            0);
                PageConfData.hptrIcon:=hptrIcon;
            END;
        END;
        WM_COMMAND:BEGIN
            CASE Short1FromMP( mp1) OF
                DID_UP:BEGIN
                    i:=WinSendMsg(hwndColumList,LM_QUERYSELECTION,0,0);
                    IF i>0 THEN BEGIN
                        j:=PageConfData.ColumAttr[i+3].ix;
                        k:=PageConfData.ColumAttr[i+3-1].ix;
                        PageConfData.ColumAttr[i+3].ix:=k;
                        PageConfData.ColumAttr[i+3-1].ix:=j;

                        pChList:=ColumList[PageConfData.ColumAttr[i+3].ix];
                        WinSendMsg(hwndColumList,
                                    LM_SETITEMTEXT,
                                    i,
                                    MPFROMP(pChList) );

                        pChList:=ColumList[PageConfData.ColumAttr[i+3-1].ix];
                        WinSendMsg(hwndColumList,
                                    LM_SETITEMTEXT,
                                    i-1,
                                    MPFROMP(pChList) );

                        WinSendDlgItemMsg(hwndDlg,
                                          DID_COLUMLIST,
                                          LM_SELECTITEM,
                                          MPFROMSHORT(i-1),
                                          ord(TRUE));
                    END;

                END;
                DID_DOWN:BEGIN
                    i:=WinSendMsg(hwndColumList,LM_QUERYSELECTION,0,0);
                    IF i<MaxColumList-3 THEN BEGIN
                        j:=PageConfData.ColumAttr[i+3].ix;
                        k:=PageConfData.ColumAttr[i+3+1].ix;
                        PageConfData.ColumAttr[i+3].ix:=k;
                        PageConfData.ColumAttr[i+3+1].ix:=j;

                        pChList:=ColumList[PageConfData.ColumAttr[i+3].ix];
                        WinSendMsg(hwndColumList,
                                    LM_SETITEMTEXT,
                                    i,
                                    MPFROMP(pChList) );

                        pChList:=ColumList[PageConfData.ColumAttr[i+3+1].ix];
                        WinSendMsg(hwndColumList,
                                    LM_SETITEMTEXT,
                                    i+1,
                                    MPFROMP(pChList));

                        WinSendDlgItemMsg(hwndDlg,
                                          DID_COLUMLIST,
                                          LM_SELECTITEM,
                                          MPFROMSHORT(i+1),
                                          ord(TRUE));
                    END;

                END;
                DID_SHOWHIDE:BEGIN
                    i:=WinSendMsg(hwndColumList,LM_QUERYSELECTION,0,0);
                    PageConfData.ColumAttr[i+3].isDisp:=
                                NOT(PageConfData.ColumAttr[i+3].isDisp);
                    WinSendDlgItemMsg(hwndDlg,
                                      DID_COLUMLIST,
                                      LM_SELECTITEM,
                                      MPFROMSHORT(i-1),
                                      ord(TRUE));
                    WinSendDlgItemMsg(hwndDlg,
                                      DID_COLUMLIST,
                                      LM_SELECTITEM,
                                      MPFROMSHORT(i),
                                      ord(TRUE));
                END;
                DID_OK:BEGIN
                    WinQueryWindowText( WinWindowFromID(hwndDlg,
                                                        DID_EDIT_CONTROL),
                                        MaxCharLength,
                                        PageConfData.pChPageName);
                    WinQueryWindowText( WinWindowFromID(hwndDlg,
                                                        DID_PAGEINFO),
                                        MaxCharLength,
                                        PageConfData.pChPageInfo);
                    rc:=WinDismissDlg(hwndDlg,Ord(TRUE));
                END;
                DID_CANCEL:
                    WinDismissDlg(hwndDlg,Ord(FALSE));
            END;
        END;(**WM_COMMNAD**)
        WM_MEASUREITEM :BEGIN
            ps := WinGetPS(hwndDlg);
            GpiQueryFontMetrics(ps,sizeof(fmMetrics),fmMetrics);
            WinReleasePS(ps);

            //lMaxCy := fmMetrics.lMaxBaselineExt;

            hbmBitmap := WinGetSysBitmap(HWND_DESKTOP,SBMP_MENUCHECK);

            bmihHeader.cbFix := 16;
            GpiQueryBitmapInfoHeader(hbmBitmap,bmihHeader);
            IF fmMetrics.lMaxBaseLineExt>bmihHeader.cy THEN
                result:=fmMetrics.lMaxBaseLineExt
            ELSE
                result:=bmihHeader.cy;
        END; { WM_MEASUREITEM }

        WM_DRAWITEM : BEGIN

            poiItem := PVOIDFROMMP(mp2);

            rclText := poiItem^.rclItem;
            rclText.xLeft := (rclText.xRight-rclText.xLeft) div 7;

            {***************************************************}
            {* draw the bitmap name                            *}
            {***************************************************}

            IF poiItem^.fsState <> 0 THEN
              BEGIN
                Col1 := CLR_YELLOW;
                Col2 := CLR_BLUE;
              END
            ELSE
              BEGIN
                Col1 := CLR_BLUE;
                Col2 := CLR_WHITE;
            END;
            WinDrawText(poiItem^.hps,
                        -1,
                        ColumList[PageConfData.ColumAttr[poiItem^.idItem+3].ix],
                        rclText,
                        Col1,
                        Col2,
                        DT_LEFT OR DT_VCENTER OR DT_ERASERECT);

            rclText := poiItem^.rclItem;
            rclText.xRight := (rclText.xRight-rclText.xLeft) div 7;

            {***************************************************}
            {* fill the rectangle with white                   *}
            {***************************************************}

            WinFillRect(poiItem^.hps,
                        rclText,
                        CLR_WHITE);
            IF PageConfData.ColumAttr[poiItem^.idItem+3].isDisp THEN BEGIN
                hbmBitmap := WinGetSysBitmap(HWND_DESKTOP,SBMP_MENUCHECK);

                {***************************************************}
                {* draw the bitmap, then delete                    *}
                {***************************************************}

                Draw1Bitmap(poiItem^.hps,
                            hbmBitmap,
                            @rclText);

                GpiDeleteBitmap(hbmBitmap);
            END;

            {***************************************************}
            {* set both states to FALSE and return TRUE        *}
            {***************************************************}

            poiItem^.fsState := ord(FALSE);
            poiItem^.fsStateOld := ord(FALSE);

            result:= Ord( True );
        END; { WM_DRAWITEM }

        ELSE BEGIN
           result:=WinDefDlgProc(hwndDlg,ulMsg,mp1,mp2);
        END;
    END;(**case**)
END;


VAR
    IconSWP:SWP;
    hwndStatic  :hwnd;
    hwndDesc,
    hwndUser,
    hwndPass,
    hwndSeri,
    hwndURL,
    hwndMemo:hwnd;
    hwndDay,hwndMonth,hwndYear:hwnd;
    hwndNoExpire:hwnd;
    ExpireDate,
    Dig30:TDateTime;

FUNCTION RecordConfDlgProc( hwndDlg: HWND ;
                          ulMsg  : ULONG;
                          mp1    : MPARAM;
                          mp2    : MPARAM ) : mResult;
VAR
    pRow,pCurRow:pRowInfo;
    pCore       :pRecordCore;
    riRecord    :RECORDINSERT;
    i           :INTEGER;
    hwndCntr    : hwnd;
    ciInfo      : CNRINFO;
    hptrIcon    :HPointer;
    ptlDrop     : PointL;
    pRowParent  :pRecordConfDataRecord;
    rclWindow   :RectL;
    rc:mresult;
    st:string;
    PROCEDURE SetSpinCntrol(b:BOOLEAN);
    BEGIN
        IF b THEN BEGIN
            rc:=WinSendMsg(hwndYear,SPBM_SETLIMITS,2032,2000);
            rc:=WinSendMsg(hwndMonth,SPBM_SETLIMITS,12,1);
            rc:=WinSendMsg(hwndDay,SPBM_SETLIMITS,31,1);
        END
        ELSE BEGIN
            rc:=WinSendMsg(hwndYear,SPBM_SETLIMITS,0,0);
            rc:=WinSendMsg(hwndMonth,SPBM_SETLIMITS,0,0);
            rc:=WinSendMsg(hwndDay,SPBM_SETLIMITS,0,0);
        END;
    END;

    PROCEDURE SetSpinDate(CurDate:TDateTime);
    VAR
        d,m,y:smallword;
    BEGIN
        DecodeDate(CurDate,y,m,d);
        rc := WinSendMsg(hwndDay,  SPBM_SETCURRENTVALUE,MPFROMSHORT(d),0);
        rc := WinSendMsg(hwndMonth,SPBM_SETCURRENTVALUE,MPFROMSHORT(m),0);
        rc := WinSendMsg(hwndYear, SPBM_SETCURRENTVALUE,MPFROMSHORT(y),0);
        ExpireDate:=CurDate;
    END;

    PROCEDURE GetSpinDate;
    VAR
        d,m,y:LONGINT;
    BEGIN
        WinSendMsg( hwndDay,SPBM_QUERYVALUE,MPFROMP(@d),0);
        WinSendMsg( hwndMonth,SPBM_QUERYVALUE,MPFROMP(@m),0);
        WinSendMsg( hwndYear,SPBM_QUERYVALUE,MPFROMP(@y),0);
        ExpireDate:=EncodeDate(y,m,d);
    END;
    FUNCTION SetEntryPCh(ID:ULong;pCh:pChar):hwnd;
    VAR
        aWnd:hwnd;
    BEGIN
        aWnd:=WinWindowFromID(hwndDlg, ID);
        WinSendMsg(aWnd,EM_SETTEXTLIMIT,MaxCharLength-1,NullHandle);
        WinSetWindowText(aWnd,pCh);
        result:=aWnd;
    END;
BEGIN
    result:=0;
    CASE(ulMsg) OF
        WM_INITDLG:BEGIN
            hwndStatic:=WinWindowFromID(hwndDlg,ID_ICONDRAW);
            @OldDropPermitProc:=WinSubClassWindow(hwndStatic,DropPermitProc);
            WinQueryWindowPos(WinWindowFromID(hwndDlg,ID_ICONFRAME),
                              IconSWP);
            pRowParent:=pRecordConfDataRecord(mp2);

            IF (pRowParent^.pChAry[1]=NIL)
               OR (StrComp(pRowParent^.pChAry[1],'')=0) THEN BEGIN
                pRowParent^.pChAry[1]:=StrPCopy(pRowParent^.pChAry[1],
                                                IntToStr(ICO_ITEM));
            END;
            pChToHPointer(pRowParent^.pChAry[1],hptrIcon);
            WinSendMsg( hwndStatic,
                        SM_SETHANDLE,
                        hptrIcon,
                        0);
            RecConfData.pChAry[1]:=StrCopy(RecConfData.pChAry[1],
                                            pRowParent^.pChAry[1]);
            hwndDesc:=SetEntryPch(ID_DESCENTRY,pRowParent^.pChAry[2]);
            hwndUser:=SetEntryPch(ID_USERENTRY,pRowParent^.pChAry[3]);
            hwndPass:=SetEntryPch(ID_PASSENTRY,pRowParent^.pChAry[4]);
            hwndURL :=SetEntryPch(ID_URLENTRY ,pRowParent^.pChAry[5]);
            hwndSeri:=SetEntryPch(ID_SNENTRY  ,pRowParent^.pChAry[6]);
            hwndMemo:=SetEntryPch(ID_MEMOENTRY,pRowParent^.pChAry[7]);

            hwndDay:=WinWindowFromID(hwndDlg,ID_DaySpin);
            hwndMonth:=WinWindowFromID(hwndDlg,ID_MonthSpin);
            hwndYear:=WinWindowFromID(hwndDlg,ID_YearSpin);

            RecConfData.isExpireCheck:=pRowParent^.isExpireCheck;
            hwndNoExpire:=WinWindowFromID(hwndDlg,ID_NoExpire);
            IF RecConfData.isExpireCheck =FALSE THEN
                WinSendMsg(hwndNoExpire,BM_SETCHECK,1,0)
            ELSE
                WinSendMsg(hwndNoExpire,BM_SETCHECK,0,0);

            SetSpinCntrol(TRUE);
            IF (isBlankpCh(pRowParent^.pChAry[9]) =FALSE) AND
               (StrComp(pRowParent^.pChAry[9],BlankStr)<>0 ) THEN BEGIN
                TRY
                    ExpireDate:=StrToDate(pRowParent^.pChAry[9]);
                EXCEPT
                    ExpireDate:=now;
                END;
                SetSpinDate(ExpireDate);
            END
            ELSE BEGIN
                SetSpinDate(now);
            END;
            IF isBlankpCh(pRowParent^.pChAry[8]) OR
               (StrComp(pRowParent^.pChAry[9],BlankStr)=0 ) THEN BEGIN
                RecConfData.pChAry[8]:=StrPCopy(RecConfData.pChAry[8],
                                                DateToStr(now));
            END;
        END;
        WM_COMMAND:BEGIN
            CASE Short1FromMP( mp1) OF
                DID_OK:BEGIN
                    WinQueryWindowText( hwndDesc,
                                        MaxCharLength,
                                        RecConfData.pChAry[2]);
                    WinQueryWindowText( hwndUser,
                                        MaxCharLength,
                                        RecConfData.pChAry[3]);
                    WinQueryWindowText( hwndPass,
                                        MaxCharLength,
                                        RecConfData.pChAry[4]);
                    WinQueryWindowText( hwndURL ,
                                        MaxCharLength,
                                        RecConfData.pChAry[5]);
                    WinQueryWindowText( hwndSeri,
                                        MaxCharLength,
                                        RecConfData.pChAry[6]);
                    WinQueryWindowText( hwndMemo,
                                        MaxCharLength,
                                        RecConfData.pChAry[7]);

                    GetSpinDate;
                    RecConfData.isExpireCheck:=NOT(bool(
                                    WinSendMsg(hwndNoExpire,
                                               BM_QUERYCHECK,
                                               0,
                                               0)));
                    RecConfData.pChAry[9]:=StrPCopy(RecConfData.pChAry[9],
                                                    DateToStr(ExpireDate));
                    RecConfData.pChAry[8]:=StrPCopy(RecConfData.pChAry[8],
                                                    DateToStr(Now));
                    WinDismissDlg(hwndDlg,Ord(TRUE));
                END;
                DID_CANCEL:
                    WinDismissDlg(hwndDlg,Ord(FALSE));
                ID_TODAY:BEGIN
                    SetSpinDate(now);
                END;
                ID_After30:BEGIN
                    SetSpinDate(ExpireDate+Dig30);
                END;
                ID_Before30:BEGIN
                    SetSpinDate(ExpireDate-Dig30);
                END;
            END;
        END;(**WM_COMMNAD**)
        DM_DragOver:BEGIN
            ptlDrop.x := SHORT1FROMMP(mp2);
            ptlDrop.y := SHORT2FROMMP(mp2);

            WinMapWindowPoints(HWND_DESKTOP,
                               hwndDlg,
                               ptlDrop,
                               1);
           IF (ptlDrop.x>=IconSWP.x) AND (ptlDrop.x<=IconSWP.x+IconSWP.cx) AND
               (ptlDrop.y>=IconSWP.y) AND (ptlDrop.y<=IconSWP.y+IconSWP.cy)
            THEN
                result:=MRFROM2SHORT(DOR_DROP, DO_MOVE);
        END;
        DM_Drop:BEGIN
            St:=DMDrop(hwndDlg,mp1,mp2);
            RecConfData.pChAry[1]:=StrPCopy(RecConfData.pChAry[1],St);
            IF pChToHPointer(RecConfData.pChAry[1],hptrIcon) THEN BEGIN
                WinSendMsg( hwndStatic,
                            SM_SETHANDLE,
                            WinLoadPointer(HWND_DESKTOP,NULLHANDLE,ICO_BLANK),
                            0);
                WinSendMsg( hwndStatic,
                            SM_SETHANDLE,
                            hptrIcon,
                            0);
            END;
        END;
        ELSE BEGIN
           result:=WinDefDlgProc(hwndDlg,ulMsg,mp1,mp2);
        END;
    END;(**case**)
END;

VAR
    hwndPassword:hwnd;
FUNCTION PasswordDlgProc( hwndDlg: HWND ;
                          ulMsg  : ULONG;
                          mp1    : MPARAM;
                          mp2    : MPARAM ) : mResult;
VAR
    pChPass:pChar;
    KeyFlag,KeyCode:SmallWord;
    PROCEDURE OkCommand;
    BEGIN
        GetMem(pChPass,MaxCharLength);
        pChPass:=StrCopy(pChPass,'');
        WinQueryWindowText( hwndPassword,MaxCharLength,pChPass);
        EntrySt:=StrPas(pChPass);
        WinDismissDlg(hwndDlg,Ord(TRUE));
    END;
    PROCEDURE MapKey;
    BEGIN
        KeyFlag:= CharMsgMp1(MP1).fs ;
        KeyCode := CharMsgMp2(MP2).VKey;
    END;

    FUNCTION isPushEnter:BOOLEAN;
    BEGIN
        result:=FALSE;
        IF KeyFlag AND KC_KEYUP <> 0 THEN EXIT;
        IF KeyFlag AND KC_VIRTUALKEY <> 0 THEN BEGIN
            IF (KeyCode=VK_NewLine) OR (KeyCode=VK_Enter) THEN BEGIN
                result:=TRUE;
            END;
        END;
    END;
    FUNCTION isPushESC:BOOLEAN;
    BEGIN
        result:=FALSE;
        IF KeyFlag AND KC_KEYUP <> 0 THEN EXIT;
        IF KeyFlag AND KC_VIRTUALKEY <> 0 THEN BEGIN
            IF (KeyCode=VK_ESC) THEN BEGIN
                result:=TRUE;
            END;
        END;
    END;
BEGIN
    result:=0;
    CASE(ulMsg) OF
        WM_INITDLG:BEGIN
            hwndPassword:=WinWindowFromID(hwndDlg,DID_ENTRY);
            WinSendMsg(hwndPassword,
                       EM_SETTEXTLIMIT,
                       MaxCharLength-1,
                       NullHandle);
        END;
        WM_COMMAND:BEGIN
            CASE Short1FromMP( mp1) OF
                DID_OK:BEGIN
                    OkCommand;
                END;
                DID_CANCEL:
                    WinDismissDlg(hwndDlg,Ord(FALSE));
            END;
        END;(**WM_COMMNAD**)
        WM_CHAR:BEGIN
            MapKey;
            IF isPushEnter THEN BEGIN
                OkCommand;
            END
            ELSE IF isPushEsc THEN BEGIN
                WinDismissDlg(hwndDlg,Ord(FALSE));
            END
            ELSE
                result:=WinDefDlgProc(hwndDlg,ulMsg,mp1,mp2);
        END;
        ELSE BEGIN
           result:=WinDefDlgProc(hwndDlg,ulMsg,mp1,mp2);
        END;
    END;(**case**)
END;

PROCEDURE RecordConfManegeProc(window:hwnd);
VAR
    CurCntr:ContainerClass;
    //CurPageID:ULong;
    rc:MResult;
    pRow:pRowInfo;
    i:INTEGER;
    hptrIcon:HPointer;

BEGIN
    CurCntr:=KrPageMan.GetCurCntr;
    pRow:=pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                              CM_QueryRecordEmphasis,
                              CMA_FIRST,
                              MPFROMSHORT(CRA_SELECTED) ));
    IF pRow=NIL THEN EXIT;

    WITH pRow^ DO BEGIN
        RecConfData.hptrIcon:=Core.hptrIcon;
        FOR i:=1 TO MaxColumList DO BEGIN
            IF pChAry[i]<>NIL THEN
                StrCopy(RecConfData.pChAry[i],pChAry[i])
            ELSE
                StrCopy(RecConfData.pChAry[i],'');
        END;
        IF Core.pszIcon<>NIL THEN
            StrCopy(RecConfData.pChAry[2],Core.pszIcon)
        ELSE
            StrCopy(RecConfData.pChAry[2],'');
        RecConfData.isExpireCheck:=isExpireCheck;
    END;
    IF WinDlgBox(HWND_DESKTOP,
                 Window,
                 RecordConfDlgProc,
                 NullHandle,
                 DLG_RecordConfig,
                 @RecConfData)=Ord(TRUE) THEN
    BEGIN
        IF pChToHPointer(RecConfData.pChAry[1],hptrIcon) THEN BEGIN
            IF isBlankpCh(RecConfData.pChAry[1]) THEN
                pRow^.pChAry[1]:=AllocStrCopy(pRow^.pChAry[1],BlankStr)
            ELSE
                pRow^.pChAry[1]:=AllocStrCopy(pRow^.pChAry[1],
                                              RecConfData.pChAry[1])
        END;

        pRow^.Core.hptrIcon:=hptrIcon;
        IF pRow^.Core.pszIcon<>NIL THEN BEGIN
            FreeMem(pRow^.Core.pszIcon,
                    StrLen(pRow^.Core.pszIcon));
            pRow^.Core.pszIcon:=NIL;
        END;
        pRow^.isExpireCheck:=RecConfData.isExpireCheck;
        pRow^.Core.pszIcon:=AllocStrCopy(pRow^.Core.pszIcon,
                                         RecConfData.pChAry[2]);

        FOR i:=3 TO MaxColumList DO BEGIN
            IF i=8 THEN BEGIN
                IF  (pRow^.pChAry[4]=NIL) OR
                    (StrComp(pRow^.pChAry[4],RecConfData.pChAry[4])<>0)OR
                NOT(isBlankpCh(RecConfData.pChAry[8])) THEN
                BEGIN
                    pRow^.pChAry[i]:=AllocStrPCopy(pRow^.pChAry[i],
                                                   DateToStr(Now));
                END;
            END
            ELSE BEGIN
                IF isBlankpCh(RecConfData.pChAry[i]) THEN
                    pRow^.pChAry[i]:=AllocStrCopy(pRow^.pChAry[i],BlankStr)

                ELSE
                    pRow^.pChAry[i]:=AllocStrCopy(pRow^.pChAry[i],
                                            RecConfData.pChAry[i]);
            END;
        END;

        WinSendMsg(CurCntr.GetHWnd,
                   CM_INVALIDATERECORD,
                   CMA_FIRST,
                   MPFROM2SHORT(0,CMA_REPOSITION));
    END;
END;


PROCEDURE PageConfManegeProc(window:hwnd);
VAR
    st:string;
    CurCntr:ContainerClass;
    CurPageID:ULong;
    rc:MResult;
    i:INTEGER;
BEGIN
    St:=KrPageMan.GetCurCntr.AppName+#0;
    PageConfData.hptrIcon:=WinLoadFileIcon(@st[1],FALSE);

    IF PageConfData.hptrIcon=NullHandle THEN BEGIN
        PageConfData.hptrIcon:=WinLoadPointer( HWND_DESKTOP,
                                               NULLHANDLE,
                                               ICO_BLANK);
    END;
    PageConfData.AppName:=KrPageMan.GetCurCntr.AppName;
    StrPCopy(PageConfData.pChPageName,KrPageMan.GetCurCntr.GroupName);
    StrPCopy(PageConfData.pChPageInfo,KrPageMan.GetCurCntr.GroupInfoStr);
    PageConfData.ColumAttr:=KrPageMan.GetCurCntr.ColumAttr;
    IF WinDlgBox(HWND_DESKTOP,
                 Window,
                 PageConfDlgProc,
                 NULLHANDLE,
                 DLG_PAGECONFIG,
                 @PageConfData)        =Ord(TRUE) THEN
    BEGIN
        CurPageID:=WinSendMsg(KrPageMan.hwndNB,
                              BKM_QUERYPAGEID,
                              CurPageID,
                              MPFROM2SHORT(BKA_TOP,BKA_MAJOR));
        WinSendMsg(KrPageMan.hwndNb,
                   BKM_SETTABTEXT,
                   CurPageID,
                   LONG(PageConfData.pChPageName));
        rc:=WinSendMsg(KrPageMan.hwndNb,
                       BKM_SETSTATUSLINETEXT,
                       CurPageID,
                       LONG(PageConfData.pChPageInfo));
        CurCntr:=KrPageMan.GetContainer(CurPageID);
        CurCntr.GroupName:=StrPas(PageConfData.pChPageName);
        CurCntr.GroupInfoStr:=StrPas(PageConfData.pChPageInfo);
        CurCntr.AppName:=PageConfData.AppName;
        CurCntr.ColumAttr:=PageConfData.ColumAttr;
        CurCntr.FlushColum;
        FOR i:=0 TO KrPageMan.ContainerList.Count-1 DO BEGIN
            CurCntr:=ContainerClass(KrPageMan.ContainerList[i]);
            IF CurCntr.id=CurPageID THEN BEGIN
                KrPageMan.RenamePageMenu(i,CurCntr.GroupName);
            END;
        END;
    END;
END;

VAR
    hwndBackupEntry:hwnd;
    hwndBackupSpin:hwnd;
    hwndBackupCheck:hwnd;
    hwndBackPane:hwnd;
FUNCTION SettingDropPermitProc( hwndAny : HWnd;
                          ulMsg     : ULong;
                          mpParm1   : MParam;
                          mpParm2   : MParam ) : mResult; cdecl;
VAR
    st:string;
    pParam:pWndParams;
BEGIN
    IF ulMsg=DM_DRAGOVER THEN BEGIN
        result:=MRFROM2SHORT(DOR_DROP, DO_MOVE);
    END
    ELSE IF ulMsg=DM_Drop THEN BEGIN
        st:=DMDrop(hwndAny,mpParm1,mpParm2);
        st:=st+#0;
        StrCopy(SettingConfData.pBackupPath,@St[1]);
        WinSetWindowText(hwndBackupEntry,SettingConfData.pBackupPath);
    END
    ELSE
        result:=OldDropPermitProc(hwndAny,ulMsg,mpParm1,mpParm2);
END;

FUNCTION SettingConfProc( hwndDlg: HWND ;
                          ulMsg  : ULONG;
                          mp1    : MPARAM;
                          mp2    : MPARAM ) : mResult;
VAR
    isUse:uShort;
    bGen:LONGINT;
    st:string;
    High,Low:INTEGER;
VAR
    pVa:pChar;
    pVaAry:ARRAY[0..3] OF CHAR;
BEGIN
    result:=0;
    CASE(ulMsg) OF
        WM_INITDLG:BEGIN
            hwndBackupEntry:=WinWindowFromID(hwndDlg,ID_BACKUPPATHENTRY);
            hwndBackupCheck:=WinWindowFromID(hwndDlg,ID_IsUseBackup);
            hwndBackupSpin:=WinWindowFromID(hwndDlg,ID_BACKUPGEN);
            hwndBackPane:=WinWindowFromID(hwndDlg,ID_BackPane);
            @OldDropPermitProc:=WinSubClassWindow(hwndBackupEntry,
                                                  SettingDropPermitProc);
            SettingConfData.isUseBackupPath:=KrPageMan.isUseBackupPath;
            WinSendMsg(hwndBackupCheck,
                       BM_SETCHECK,
                       Ord(SettingConfData.isUseBackupPath),
                       0);
            IF KrPageMan.isUseBackupPath THEN BEGIN
                st:=KrPageMan.BackupPath+#0;
                WinSetWindowText(hwndBackupEntry,@st[1]);
            END;
            High:=9;low:=4;
            WinSendMsg( hwndBackupSpin,
                        SPBM_SETLIMITS,
                        High,
                        Low);
            WinSendMsg( hwndBackupSpin,
                        SPBM_SETCURRENTVALUE,
                        MParam(GenMax),
                        0);
            WinEnableWindow(hwndBackupEntry,
                            SettingConfData.isUseBackupPath);
                        
        END;
        WM_COMMAND:BEGIN
            CASE Short1FromMP( mp1) OF
                DID_OK:BEGIN
                    isUse:=WinSendMsg(hwndBackupCheck,BM_QUERYCHECK,0,0);
                    WinSendMsg(hwndBackupSpin,
                                SPBM_QUERYVALUE,
                                MPFROMP(@bGen),
                                0);
                    SettingConfData.isUseBackupPath:=BOOLEAN(isUse);
                    SettingConfData.BackupGen:=bGen;
                    WinQueryWindowText( hwndBackupEntry,
                                        MaxCharLength,
                                        SettingConfData.pBackupPath);
                    WinDismissDlg(hwndDlg,Ord(true));
                    WinEnableWindow(hwndBackupEntry,
                                    SettingConfData.isUseBackupPath);
                END;
                DID_CANCEL:
                    WinDismissDlg(hwndDlg,Ord(FALSE));
            END;
        END;(**WM_COMMNAD**)
        WM_CONTROL:BEGIN
            CASE short1frommp(mp1) OF
                ID_ISUseBackup:BEGIN
                    SettingConfData.isUseBackupPath:=
                        NOT(SettingConfData.isUseBackupPath);
                    WinEnableWindow(hwndBackupEntry,
                                    SettingConfData.isUseBackupPath);
                END;
            END;
        END;
        ELSE BEGIN
           result:=WinDefDlgProc(hwndDlg,ulMsg,mp1,mp2);
        END;
    END;
END;

VAR
    i:INTEGER;
BEGIN
    GetMem(pCh,MaxCharLength);
    GetMem(PageConfData.pChPageName,MaxCharLength);
    GetMem(PageConfData.pChPageInfo,MaxCharLength);
    GetMem(SettingConfData.pBackupPath,MaxCharLength);
    FOR i:=1 TO MaxColumList DO BEGIN
        GetMem(RecConfData.pChAry[i],MaxCharLength);
//        RecConfData.pChAry[i]:=NIL;
//        StrCopy(RecConfData.pChAry[i],' ');
    END;
    Dig30:=EncodeDate(2006,1,31)-EncodeDate(2006,1,1);
    ShortDateFormat:='yyyy/mm/dd';
    PassConfData.isUse:=FALSE;
    PassConfData.password:='';
END.

SPBM_
TDateTime
CBM_
CHECKBUTTON
