(**$Revision: 1.4.7.8 $**)
PROGRAM Krm15;
USES
    Classes,os2def,os2pmapi,
    SysUtils,VPUtils,
    NuCell,xmlRead,xmlWrite,dom,XMLCfg,TextInis,
    KrDialog,KrUnit;

{$PMTYPE PM}
{$R krm.res}
{$I krm.inc}
{$H+}
TYPE
    FilterCommandRecord=RECORD
        isFilter:BOOLEAN;
    END;
    pFilterCommand=^FilterCommandRecord;

FUNCTION MainClientProc(Window:
                        HWnd; Msg:
                        ULong;
                        Mp1,Mp2: MParam): MResult; cdecl; forward;

FUNCTION ContainerClientProc(Window:
                             HWnd; Msg:
                             ULong;
                             Mp1,Mp2: MParam): MResult; cdecl; forward;

(**GUI Cell Definition**)
CONST
    AppTitle='KeyRing1.5';
    cdCntPane:CellDef =
        (lType: Cell_WINDOW;
         pszClass:WC_CONTAINER;
         pszName:'test';
         ulStyle:CCS_SINGLESEL OR WS_VISIBLE;
         ulID:ID_CONTAINER);

    nbClient:CellDef =
        (lType:CELL_VSPLIT ;
         pszClass:NIL;
         pszName:'Notebook page';
         ulStyle:0;
         ulID:MAIN_FRAME;
         pPanel1:@cdCntPane;
         pPanel2:NIL;
         pClassProc:NIL;
         pClientClassProc:ContainerClientProc);

    nbConigClient:CellDef=
        (lType:CELL_VSPLIT ;
         pszClass:NIL;
         pszName:'Notebook page';
         ulStyle:0;
         ulID:MAIN_FRAME;
         pPanel1:NIL;
         pPanel2:NIL;
         pClassProc:NIL;
         pClientClassProc:NIL);

    nbPanel:CellDef=
        (lType:CELL_WINDOW;
         pszClass:WC_NOTEBOOK;
         pszName:'';
         ulStyle:WS_VISIBLE OR BKS_TABBEDDIALOG OR BKS_MAJORTABTOP;
         ulID:ID_NOTEBOOK);

    mainFrame:CellDef=
        (lType:CELL_HSPLIT;
         pszClass:NIL;
         pszName:AppTitle;
         ulStyle:FCF_TITLEBAR OR FCF_SYSMENU OR FCF_MENU OR
                 FCF_ICON OR FCF_MINMAX OR FCF_TASKLIST OR
                 FCF_SIZEBORDER OR FCF_ACCELTABLE ;
         ulID:MAIN_FRAME;
         pPanel1:@nbPanel;
         pPanel2:NIL;
         pClassProc:NIL;
         pClientClassProc:MainClientProc);

    mainItems:ARRAY [0..12] OF TBItemData=(
        (NuID: IDB_FILEOPEN   ;cText:''),
        (NuID: IDB_FILESAVE   ;cText:''),
        (NuID: IDB_FILSAVAS   ;cText:''),
        (NuID: TB_SEPARATOR   ;cText:''),
        (NuID: IDB_PAGECONF   ;cText:''),
        (NuID: IDB_CONFIG     ;cText:''),
        (NuID: ID_FilterExpire;cText:''),
        (NuID: IDB_Exec       ;cText:''),
        (NuID: TB_SEPARATOR   ;cText:''),
        (NuID: IDB_EXIT       ;cText:''),
        (NuID: TB_SEPARATOR   ;cText:''),
        (NuID: IDB_UNLOCK       ;cText:''),
        (NuID:0) );

    mainTb:TbDef=
        (lType:TB_ATTACHED_TP OR TB_BUBBLE;
         ulID:ID_TOOLBAR;
         tbItems:@mainItems);
FUNCTION GetStateBitmap(Window:hwnd):hbitmap;
VAR
    HPSTemp:hps;
    HB:HBitmap;
BEGIN
    HPSTemp:=WinGetPS(Window);
    CASE KrPageMan.DispState OF
        Normal:BEGIN
            HB:=GpiLoadBitmap(HPSTemp,0,IDB_UNLOCK,0,0);
        END;
        Hide:BEGIN
            HB:=GpiLoadBitmap(HPSTemp,0,IDB_LOCK,0,0);
        END;
        NoDisp:BEGIN
            HB:=GpiLoadBitmap(HPSTemp,0,IDB_FULLLOCK,0,0);
        END;
    END;
    result:=HB;
END;

PROCEDURE MakeLockButtonState;
VAR
    NuTB:NuTBClass;
BEGIN
    NuTB:=NuTBList.GetTBClass(IDB_UNLOCK);
    WinSendMsg(NuTB.NuWnd,
               SM_SETHANDLE,
                GetStateBitmap(NuTB.NuWnd),
                0);

END;

FUNCTION FilterExpire(pRow:pRowInfo;pCommand:pFilterCommand) :Bool;cdecl;
VAR
    st:string;
    EvalDate:TDateTime;
    y,m,d:SmallWord;
BEGIN
    IF pCommand^.isFilter=FALSE THEN
        FilterExpire:=TRUE
    ELSE BEGIN
        IF (pRow^.isExpireCheck=FALSE) THEN BEGIN
            FilterExpire:=FALSE;
        END
        ELSE BEGIN
            IF isBlankpCh(pRow^.pChAry[9]) THEN BEGIN
                FilterExpire:=FALSE;
            END
            ELSE BEGIN
                EvalDate:=StrToDate(StrPas(pRow^.pChAry[9]));
                DecodeDate(EvalDate,y,m,d);
                EvalDate:=Now-EvalDate;
                FilterExpire:=(EvalDate>0);
            END;
        END
    END;
END;


FUNCTION SortByColum(pRowFirst,pROwSecond:pRowInfo;
                     pSortOffset:pSmallInt):SmallInt; cdecl;
VAR
    p1,p2:pChar;
BEGIN
    IF pSortOffset^=2 THEN BEGIN
        p1:=pRowFirst^.Core.pszIcon;
        p2:=pRowSecond^.Core.pszIcon;
    END
    ELSE BEGIN
        p1:=pRowFirst^.pChAry[pSortOffset^];
        p2:=pRowSecond^.pChAry[pSortOffset^];
    END;
    IF p1=NIL THEN p1:='';
    IF p2=NIL THEN p2:='';
    SortByColum:=StrComp( p1,p2);
END; { SortRecords }

CONST
    KrCfgIniName='krcfg.ini';
    krCfgWindow='window';
    KrCfgBackup='Backup';
    KrCfgRecent='RecentUse';
    KrCfgRecentFN='RecentFile';
VAR
    KrCfgIni:TTextIniFile;
    xWidth,yHeight,xPos,yPos:INTEGER;

FUNCTION GetCfgFileName:string;
VAR
    path:string;
BEGIN
    Path:=ExtractFilePath(ParamStr(0));
    GetCfgFileName:=Path+'\'+KrCfgIniName;
END;

PROCEDURE ReadCfg;
VAR
    Bktemp:INTEGER;
    i:INTEGER;
    st:string;
BEGIN
    BkTemp:=GenMax;
    KrCfgIni:=TTextIniFile.Create(GetCfgFileName);
    xPos:=KrCfgIni.ReadInteger(KrCfgWindow,'x',xPos);
    yPos:=KrCfgIni.ReadInteger(KrCfgWindow,'y',yPos);
    xWidth:=KrCfgIni.ReadInteger(KrCfgWindow,'Width',xWidth);
    yHeight:=KrCfgIni.ReadInteger(KrCfgWindow,'Height',yHeight);
    GenMax:=KrCfgIni.ReadInteger(KrCfgBackup,'Generation',GenMax);
    IF GenMax<BkTemp THEN
        GenMax:=BkTemp;
    IF GenMax>9 THEN
        GenMax:=9;
    KrPageMan.isUseBackupPath:=KrCfgIni.ReadBool(KrCfgBackup,
                                                 'isUsePath',
                                                 KrPageMan.isUseBackupPath);
    KrPageMan.isUseStatus:=KrCfgIni.ReadBool(KrCfgBackup,'isUseStatus',
                                                 KrPageMan.isUseStatus);
    KrPageMan.BackupPath:=KrCfgIni.ReadString(KrCfgBackup,'path','');
    FOR i:=1 TO RecentMaxLimits DO BEGIN
        st:=KrCfgIni.ReadString(KrCfgRecent,KrCfgRecentFN+IntToStr(i),'');
        IF st<>'' THEN
            KrPageMan.AddRecent(st);
    END;
    KrCfgIni.Free;
END;

PROCEDURE WriteCfg;
VAR
    swap:os2pmapi.Swp;
    i:INTEGER;
    St1,St2:string;
BEGIN
//    HALT;
    WinQueryWindowPos(KrPageMan.FrameWindow,swap);
    xPos:=swap.x;
    yPos:=swap.y;
    xWidth:=swap.cx;
    yHeight:=swap.cy;

    KrCfgIni:=TTextIniFile.Create(GetCfgFileName);
    KrCfgIni.WriteInteger(KrCfgWindow,'x',xPos);
    KrCfgIni.WriteInteger(KrCfgWindow,'y',yPos);
    KrCfgIni.WriteInteger(KrCfgWindow,'Width',xWidth);
    KrCfgIni.WriteInteger(KrCfgWindow,'Height',yHeight);
    KrCfgIni.WriteInteger(KrCfgBackup,'Generation',GenMax);
    KrCfgIni.WriteBool(KrCfgBackup,'isUsePath',KrPageMan.isUseBackupPath);
    KrCfgIni.WriteBool(KrCfgBackup,'isUseStatus',KrPageMan.isUseStatus);
    KrCfgIni.WriteString(KrCfgBackup,'path',KrPageMan.BackupPath);
    KrPageMan.PushRecent(KrPageMan.DataDoc.GetFileName);
    FOR i:=1 TO KrPageMan.GetRecentCount DO BEGIN
        St1:=KrCfgRecentFN+IntToStr(i);
        St2:=KrPageMan.GetRecent(i);
        KrCfgIni.WriteString(KrCfgRecent,St1,St2);
    END;
    KrCfgIni.Free;
END;

PROCEDURE  SetFileCrypt(VAR st:string);
BEGIN
    IF UpperCase(ExtractFileExt(St))='.CRP' THEN BEGIN
        IF WinDlgBox(HWND_DESKTOP,
                     KrPageMan.FrameWindow,
                     PasswordDlgProc,
                     NullHandle,
                     DLG_PASSWORD,
                     NIL) =Ord(TRUE) THEN
        BEGIN
            IF EntrySt='' THEN BEGIN
                KrPageMan.DataDoc.isUseCrypt:=FALSE;
                System.Delete(st,
                              Length(st)-Length(ExtractFileExt(st)),
                              Length(ExtractFileExt(st)));
                St:=St+'.xml';
            END
            ELSE BEGIN;
                KrPageMan.DataDoc.isUseCrypt:=TRUE;
                KrPageMan.DataDoc.Password:=EntrySt;
            END;
        END
    END
    ELSE BEGIN
        KrPageMan.DataDoc.isUseCrypt:=FALSE;
    END;
END;


FUNCTION MainClientProc(Window: HWnd; Msg: ULong; Mp1,Mp2: MParam): MResult;
VAR
    pWCtlData:PWindowCellCtlData;

    k:ULong;
    pRow:pRowInfo;
    CurCntr:ContainerClass;
    CurPageID:ULong;
    ParamCommand:FilterCommandRecord;
    bkCol,rc:ULong;
    St,OrgSt:String;
    OrgUseCrypt:BOOLEAN;
    OrgPassword:string;
    RecentID:INTEGER;
    PROCEDURE CommandProc;
    VAR
        i:INTEGER;
    BEGIN
        CASE SHORT1FROMMP(mp1) OF
            IDB_EXIT:BEGIN
                IF KrPageMan.FlushSave THEN BEGIN;
                    WriteCfg;
                    WinPostMsg(Window, WM_QUIT, 0, 1);
                END;
            END;
            IDB_VIEWDETAIL:BEGIN
                KrPageMan.GetCurCntr.SetStyle(  CV_DETAIL OR
                                                CA_DETAILSVIEWTITLES );
            END;
            IDB_VIEWICON:BEGIN
                KrPageMan.GetCurCntr.SetStyle(  CV_ICON OR
                                                CA_DETAILSVIEWTITLES );
            END;
            IDB_VIEWSMALLICON:BEGIN
                KrPageMan.GetCurCntr.SetStyle(  CV_ICON OR
                                                CV_MINI OR
                                                CA_DETAILSVIEWTITLES );
            END;
            ID_FILEIMPORT:BEGIN
                IF FindFile(KrPageMan.FrameWindow,St)THEN BEGIN
                    KrPageMan.DataDoc.SetModify;
                    KrPageMan.ImportData(st,nbClient);
                    IF OrgSt='' THEN BEGIN
                        IF KrPageMan.DataDoc.isUseCrypt THEN
                            OrgSt:='new.crp'
                        ELSE
                            OrgSt:='new.xml';
                    END;
                    KrPageMan.SetDocName(OrgSt);
                    KrPageMan.DataDoc.FlushXMLData;
                END;
            END;
            IDB_FILESAVE:BEGIN
                KrPageMan.DataDoc.SetModify;
                St:=KrPageMan.DataDoc.GetFileName;
                St:=UpperCase(ExtractFileExt(St));
                    OrgSt:=KrPageMan.DataDoc.GetFileName;
                    System.Delete(OrgSt,Length(OrgSt)-length(st)+1,length(st));
                IF OrgSt='' THEN BEGIN
                    OrgSt:=workfilename;
                    IF KrPageMan.DataDoc.isUseCrypt THEN
                        OrgSt:=OrgSt+'.crp'
                    ELSE;
                        OrgSt:=OrgSt+'.xml';
                    rc:=WinMessageBox(HWND_DESKTOP,
                                      ErrorMsgWnd,
                                      @pChSaveError,
                                      'Warning Message',
                                      0,
                                      MB_OK );
                END
                ELSE BEGIN
                    OrgSt:=KrPageMan.DataDoc.GetFileName;
                END;
                KrPageMan.SetDocName(OrgSt);
                KrPageMan.DataDoc.OverWriteDoc;
                KrPageMan.DataDoc.SetUnModify;
            END;
            IDB_FILSAVAS:BEGIN
                IF FindFile(KrPageMan.FrameWindow,St) THEN BEGIN
                    OrgSt:=KrPageMan.DataDoc.GetFileName;
                    OrgUseCrypt:=KrPageMan.DataDoc.isUseCrypt;
                    KrPageMan.SetDocName(st);
                    SetFileCrypt(st);
                    KrPageMan.DataDoc.SetModify;
                    IF KrPageMan.DataDoc.OverWriteDoc =FALSE THEN BEGIN
                        KrPageMan.SetDocName(OrgSt);
                        KrPageMan.DataDoc.isUseCrypt:=OrgUseCrypt;
                    END;
                    KrPageMan.DataDoc.SetUnModify;
                    KrPageMan.DataDoc.FlushXMLData;
                END;
            END;
            ID_FILEEXPORT:BEGIN
                OrgSt:=KrPageMan.DataDoc.GetFileName;
                OrgUseCrypt:=KrPageMan.DataDoc.isUseCrypt;
                OrgPassword:=KrPageMan.DataDoc.Password;
                IF FindFile(KrPageMan.FrameWindow,St)THEN BEGIN
                    SetFileCrypt(st);
                    KrPageMan.SetDocName(st);
                    KrPageMan.DataDoc.OverWriteDoc;

                    KrPageMan.SetDocName(OrgSt);
                    KrPageMan.DataDoc.isUseCrypt:=OrgUseCrypt;
                    KrPageMan.DataDoc.Password:=OrgPassword;
                END;
            END;
            ID_NewPage:BEGIN
                KrPageMan.DataDoc.SetModify;
                KrPageMan.CreateBlankPage(nbClient);
                CurCntr:=
                    ContainerClass(KrPageMan.ContainerList[
                                      KrPageMan.ContainerList.Count-1]);
                WinSendMsg(KrPageMan.hwndNb,
                           BKM_TURNTOPAGE,
                           CurCntr.id,
                           CurCntr.Gethwnd);
            END;
            ID_DeletePage:BEGIN
                KrPageMan.DataDoc.SetModify;
                KrPageMan.DeletePage;
            END;
            IDB_PAGECONF:BEGIN
                KrPageMan.DataDoc.SetModify;
                PageConfManegeProc(window);
            END;
            IDB_CONFIG:BEGIN
                KrPageMan.DataDoc.SetModify;
                RecordConfManegeProc(window);
            END;
            IDB_EXEC:BEGIN
                CurCntr:=KrPageMan.GetCurCntr;
                pRow:=
                  pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                                      CM_QueryRecordEmphasis,
                                      CMA_FIRST,
                                      MPFROMSHORT(CRA_SELECTED) ));
                IF pRow=NIL THEN EXIT;
                St:=StrPas(pRow^.pChAry[5]);
                KrPageMan.RunExec(CurCntr.AppName,St);
            END;
            IDB_UNLOCK:BEGIN
                KrPageMan.DataDoc.SetModify;
                CurCntr:=KrPageMan.GetCurCntr;
                IF KrPageMan.DispState<>nodisp THEN
                    KrPageMan.DispState:=SUCC(KrPageMan.DispState)
                ELSE
                    KrPageMan.DispState:=Normal;
                MakeLockButtonState;
                FOR i:=0 TO KrPageMan.ContainerList.count-1 DO BEGIN
                    ContainerClass(KrPageMan.ContainerList[i]).FlushColum;
                END;
//                    CurCntr.ReInsertColum;
            END;
            ID_NewRecord:BEGIN
                KrPageMan.DataDoc.SetModify;
                CurCntr:=KrPageMan.GetCurCntr;
                IF CurCntr.isColum =FALSE THEN
                    CurCntr.SetColum;
                CurCntr.InsertNewRecord;
                WinSendMsg(CurCntr.GetHWnd,CM_INVALIDATERECORD,0,0);
                IF KrPageMan.DataDoc.isDoc=FALSE THEN BEGIN
                    IF KrPageMan.DataDoc.isUseCrypt THEN
                        KrPageMan.SetDocName('new.crp')
                    ELSE
                        KrPageMan.SetDocName('new.xml');
                END;
            END;
            ID_DeleteRecord:BEGIN
                KrPageMan.DataDoc.SetModify;
                KrPageMan.GetCurCntr.DeleteRecord;
            END;
            ID_FilterExpire:BEGIN
                CurCntr:=KrPageMan.GetCurCntr;
                CurCntr.isFilter:=NOT(CurCntr.isFilter);
                ParamCommand.isFilter:=CurCntr.isFilter;
                IF ParamCommand.isFilter THEN BEGIN
                    BkCol:=$00FFAAFF;
                    WinSetPresParam(CurCntr.GetHWnd,
                                    PP_BACKGROUNDCOLOR,
                                    4,
                                    @BkCol);
                END
                ELSE BEGIN
                    BkCol:=SYSCLR_WINDOWTEXT;
                    WinSetPresParam(CurCntr.GetHWnd,
                                    PP_BACKGROUNDCOLOR,
                                    4,
                                    @BkCol);
                END;
                WinSendMsg( CurCntr.GetHWnd,
                            CM_FILTER,
                            MPFROMP(@FilterExpire),
                            MPFROMP(@ParamCommand) );
            END;
            ID_CopyTo .. ID_CopyTo+99:BEGIN
                KrPageMan.DataDoc.SetModify;
                CurCntr:=KrPageMan.GetCurCntr;
                pRow:=
                  pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                                      CM_QueryRecordEmphasis,
                                      CMA_FIRST,
                                      MPFROMSHORT(CRA_SELECTED) ));

                k:=SHORT1FROMMP(mp1)-ID_CopyTo;
                CurCntr:=ContainerClass(KrPageMan.ContainerList[k]);
                IF CurCntr.isColum =FALSE THEN
                    CurCntr.SetColum;
                CurCntr.CopyRecord(pRow);
                WinSendMsg(CurCntr.GetHWnd,CM_INVALIDATERECORD,0,0)
            END;
            ID_MoveTo .. ID_MoveTo+99:BEGIN
                KrPageMan.DataDoc.SetModify;
                CurCntr:=KrPageMan.GetCurCntr;
                pRow:=
                  pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                                      CM_QueryRecordEmphasis,
                                      CMA_FIRST,
                                      MPFROMSHORT(CRA_SELECTED) ));

                k:=SHORT1FROMMP(mp1)-ID_MoveTo;
                CurCntr:=ContainerClass(KrPageMan.ContainerList[k]);
                IF CurCntr.isColum =FALSE THEN
                    CurCntr.SetColum;
                CurCntr.MoveRecord(pRow);
                KrPageMan.GetCurCntr.DeleteRecord;
                WinSendMsg(CurCntr.GetHWnd,CM_INVALIDATERECORD,0,0)
            END;
            ID_SORTBYICON:BEGIN
                i:=1;
                WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                            CM_SORTRECORD,
                            MPFROMP(@SortByColum),
                            MPFROMP(@i) );
            END;
            ID_SORTBYDESC:BEGIN
                i:=2;
                WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                            CM_SORTRECORD,
                            MPFROMP(@SortByColum),
                            MPFROMP(@i) );
            END;
            ID_SORTBYUSER:BEGIN
                i:=3;
                WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                            CM_SORTRECORD,
                            MPFROMP(@SortByColum),
                            MPFROMP(@i) );
            END;
            ID_SORTBYURL:BEGIN
                i:=5;
                WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                            CM_SORTRECORD,
                            MPFROMP(@SortByColum),
                            MPFROMP(@i) );
            END;
            ID_SORTBYSN:BEGIN
                i:=6;
                WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                            CM_SORTRECORD,
                            MPFROMP(@SortByColum),
                            MPFROMP(@i) );
            END;
            ID_SORTBYUPDATE:BEGIN
                i:=8;
                WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                            CM_SORTRECORD,
                            MPFROMP(@SortByColum),
                            MPFROMP(@i) );
            END;
            ID_COPYUSR:BEGIN
                pRow:=
                  pRowInfo(WinSendMsg(KrPageMan.GetCurCntr.GetHWnd,
                                      CM_QueryRecordEmphasis,
                                      CMA_FIRST,
                                      MPFROMSHORT(CRA_SELECTED) ));
                IF pRow<>NIL THEN
                    KrPageMan.CopyClip(pRow^.pChAry[3]);
            END;
            ID_COPYPASS:BEGIN
                pRow:=
                  pRowInfo(WinSendMsg(KrPageMan.GetCurCntr.GetHWnd,
                                      CM_QueryRecordEmphasis,
                                      CMA_FIRST,
                                      MPFROMSHORT(CRA_SELECTED) ));
                IF pRow<>NIL THEN
                    KrPageMan.CopyClip(pRow^.pChAry[4]);
            END;
            ID_COPYURL:BEGIN
                pRow:=
                  pRowInfo(WinSendMsg(KrPageMan.GetCurCntr.GetHWnd,
                                      CM_QueryRecordEmphasis,
                                      CMA_FIRST,
                                      MPFROMSHORT(CRA_SELECTED) ));
                IF pRow<>NIL THEN
                    KrPageMan.CopyClip(pRow^.pChAry[5]);
            END;
            ID_COPYSERIAL:BEGIN
                pRow:=
                  pRowInfo(WinSendMsg(KrPageMan.GetCurCntr.GetHWnd,
                                      CM_QueryRecordEmphasis,
                                      CMA_FIRST,
                                      MPFROMSHORT(CRA_SELECTED) ));
                IF pRow<>NIL THEN
                    KrPageMan.CopyClip(pRow^.pChAry[6]);
            END;
            ID_COPYMEMO:BEGIN
                pRow:=
                  pRowInfo(WinSendMsg(KrPageMan.GetCurCntr.GetHWnd,
                                      CM_QueryRecordEmphasis,
                                      CMA_FIRST,
                                      MPFROMSHORT(CRA_SELECTED) ));
                IF pRow<>NIL THEN
                    KrPageMan.CopyClip(pRow^.pChAry[7]);
            END;
            IDB_FILEOPEN:BEGIN
                KrPageMan.DataDoc.isUseCrypt:=FALSE;
                IF FindFile(KrPageMan.FrameWindow,St) THEN BEGIN
                    IF KrPageMan.isData THEN BEGIN
                        KrPageMan.RunExec(ParamStr(0),St)
                    END
                    ELSE BEGIN
                        SetFileCrypt(st);
                        KrPageMan.LoadData(st,nbClient);
                        MakeLockButtonState;
                    END;
                END;
            END;
            IDB_FILENEW:BEGIN
                KrPageMan.DataDoc.SetModify;
                KrPageMan.RunExec(ParamStr(0),'');
            END;
            ID_Recent1..ID_Recent5:BEGIN
                RecentID:=SHORT1FROMMP(mp1) -ID_Recent0;
                St:=KrPageMan.GetRecent(RecentID);
                IF KrPageMan.isData THEN BEGIN
                    KrPageMan.RunExec(ParamStr(0),St)
                END
                ELSE BEGIN
                    SetFileCrypt(st);
                    KrPageMan.LoadData(st,nbClient);
                    MakeLockButtonState;
                END;
            END;
            ID_SETTING:BEGIN
                IF WinDlgBox(HWND_DESKTOP,
                             KrPageMan.FrameWindow,
                             SettingConfProc,
                             NullHandle,
                             DLG_Setting,
                             NIL) =Ord(TRUE) THEN
                BEGIN
                    GenMax:=SettingConfData.BackupGen;
                    KrPageMan.isUseBackupPath:=SettingConfData.isUseBackupPath;
                    KrPageMan.BackupPath:=StrPas(SettingConfData.pBackupPath);
                END;
            END;
            ID_USEYES:BEGIN
                KrPageMan.isUseStatus:=TRUE;
                KrPageMan.FlushPageMenu;
                KrPageMan.CreatePageMenu;
                ActiveSubMenu(KrPageMan.FrameWindow,
                              ID_OPTIONMENU,
                              ID_USESTATUS,
                              ID_USEYES,
                              TRUE);
                ActiveSubMenu(KrPageMan.FrameWindow,
                              ID_OPTIONMENU,
                              ID_USESTATUS,
                              ID_USENO,
                              FALSE);
            END;
            ID_USENO:BEGIN
                KrPageMan.isUseStatus:=FALSE;
                KrPageMan.FlushPageMenu;
                KrPageMan.CreatePageMenu;
                ActiveSubMenu(KrPageMan.FrameWindow,
                              ID_OPTIONMENU,
                              ID_USESTATUS,
                              ID_USEYES,
                              FALSE);
                ActiveSubMenu(KrPageMan.FrameWindow,
                              ID_OPTIONMENU,
                              ID_USESTATUS,
                              ID_USENO,
                              TRUE);
            END;
        END;
    END;
BEGIN
    pWCtlData:=PWindowCellCtlData(WinQueryWindowULong(Window,QWL_USER));
    result   :=0;
    CASE msg OF
        WM_CREATE:BEGIN
        END;
        WM_COMMAND:BEGIN
            commandProc;
        END;
        WM_CLOSE:BEGIN
            IF KrPageMan.FlushSave THEN BEGIN
                WriteCfg;
                WinPostMsg(Window,WM_QUIT,0,0);
            END;
        END;
        ELSE BEGIN
            IF pWCtlData<>NIL THEN
                result:=pWCtlData^.pOldProc(Window, msg, mp1, mp2)
            ELSE
                result:=WinDefWindowProc(Window, msg, mp1, mp2);
        END;
    END;(**case msg**)
END;

FUNCTION ContainerClientProc(Window:HWnd;Msg:ULong;Mp1,Mp2:MParam):MResult;
VAR
   pWCtlData:PWindowCellCtlData;
   pCnrEdit:pCNREDITDATA;
   pRI:pRowInfo;
   nCh:pChar;
   hwndCnr,hwndMLE:hwnd;
   AryIndex:INTEGER;
   newsize:INTEGER;
   DataOffset:ULong;
   pInfo:pCnrInfo;
   Info:CnrInfo;
   CurPageID:ULong;
   CurCntr:ContainerClass;
   pRow:pRowInfo;
   ptl:PointL;
   OldPassword:pChar;
   OldUpdate:pChar;
   st:string;
   i,k:INTEGER;
BEGIN
    pWCtlData:=PWindowCellCtlData(WinQueryWindowULong(Window,QWL_USER));
    result   :=0;
    CASE msg OF
        WM_CONTROL:BEGIN
            CASE SHORT2FROMMP(mp1) OF
                CN_ENDEDIT:BEGIN
                    pCnrEdit:=pCNREDITDATA(mp2);
                    IF pCnrEdit^.pFieldInfo<>NIL THEN
                        DataOffset:=pCnrEdit^.pFieldInfo^.Offstruct
                    ELSE
                        DataOffset:=SizeOf(RecordCore)-1;
                    IF DataOffset>SizeOf(RecordCore)+24 THEN EXIT;
                    NewSize:=pCnrEdit^.cbText+1;
                    pRI:=pRowInfo(pCnrEdit^.pRecord);
                    hwndCnr:=pCnrEdit^.hwndCnr;
                    hwndMLE:=WinWindowFromID(hwndCnr,CID_MLE);
                    AryIndex:=(DataOffset-SizeOF(RECORDCORE)) div 4 +1;
                    OldPassword:=NIL;
                    OldUpdate:=NIL;
                    OldPassword:=AllocStrCopy(OldPassword,pRI^.pChAry[4]);
                    OldUpdate:=AllocStrCopy(OldUpdate,pRI^.pChAry[8]);
                    IF NewSize<MaxCharLength THEN
                        NewSize:=MaxCharLength;
                    GetMem(nCh,NewSize);
                    WinQueryWindowText( hwndMLE, NewSize, nCh);
                    IF isBlankpCh(nCh) THEN
                       nCh:=AllocStrCopy(nCh,BlankStr);
                    IF DataOffset<SizeOf(RECORDCORE) THEN BEGIN
                        FreeMem(pRI^.Core.pszIcon,
                                StrLen(pRI^.Core.pszIcon));
                        pRI^.Core.pszIcon:=nCh;
                    END
                    ELSE BEGIN
                        FreeMem(pRI^.pChAry[AryIndex],
                                StrLen(pRI^.pChAry[AryIndex]));
                        pRI^.pChAry[AryIndex]:=nCh;;
                    END;

                    IF (StrComp(pRI^.pChAry[4],OldPassword)<>0)
                    OR isBlankpCh(pRI^.pChAry[8]) THEN
                        pRI^.pChAry[8]:=AllocStrPCopy(pRI^.pChAry[8],
                                                      DateToStr(now));
                    KrPageMan.DataDoc.SetModify;
                END;(**CN_ENDEDIT**)
                CN_CONTEXTMENU:BEGIN
                    CurPageID:=WinSendMsg(KrPageMan.hwndNB,
                                          BKM_QUERYPAGEID,
                                          CurPageID,
                                          MPFROM2SHORT(BKA_TOP,BKA_MAJOR));

                    pRow:=pRowInfo(mp2);
                    WinQueryPointerPos(HWND_DESKTOP,ptl);
                    WinMapWindowPoints(HWND_DESKTOP,Window,ptl,1);
                    IF pRow<>NIL THEN BEGIN
                        KrPageMan.hwndConMenu:=
                            WinLoadMenu(KrPageMan.FrameWindow,
                                        NullHandle,
                                        ID_CONTEXTMENU);
                        DeleteMenu(KrPageMan.hwndConMenu,
                                   ID_MoveRecord,MoveToIndex);
                        DeleteMenu(KrPageMan.hwndConMenu,
                                   ID_CopyRecord,CopyToIndex);

                        FOR i:=0 TO KrPageMan.ContainerList.Count-1 DO BEGIN
                            CurCntr:=ContainerClass(KrPageMan.ContainerList[i]);
                            St:=CurCntr.GroupName;
                            InsertSubMenu(KrPageMan.hwndConMenu,
                                          ID_CopyRecord,
                                          ID_ContextCopy+i,
                                          St);

                            InsertSubMenu(KrPageMan.hwndConMenu,
                                          ID_MoveRecord,
                                          ID_ContextMove+i,
                                          St);
                        END;
                        WinPopUpMenu(Window,
                                     Window,
                                     KrPageMan.hwndConMenu,
                                     ptl.x,
                                     ptl.y,
                                     ID_CONTEXTMENU,
                                     PU_HCONSTRAIN OR PU_VCONSTRAIN OR
                                     PU_KEYBOARD OR PU_MOUSEBUTTON1 OR
                                     PU_MOUSEBUTTON2 OR PU_NONE);
                    END
                    ELSE BEGIN
                        KrPageMan.hwndConMenu:=
                            WinLoadMenu(KrPageMan.FrameWindow,
                                        NullHandle,
                                        ID_CONTEXTMENU2);

                        WinPopUpMenu(Window,
                                     Window,
                                     KrPageMan.hwndConMenu,
                                     ptl.x,
                                     ptl.y,
                                     ID_CONTEXTMENU2,
                                     PU_HCONSTRAIN OR PU_VCONSTRAIN OR
                                     PU_KEYBOARD OR PU_MOUSEBUTTON1 OR
                                     PU_MOUSEBUTTON2 OR PU_NONE);
                    END;
                END;
                CN_ENTER:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                               WM_COMMAND,
                               ID_ConfRecord,
                               0);
                END;
            END;(**case**)
        END;(**wm_control**)
        WM_COMMAND:BEGIN
            CASE SHORT1FROMMP(mp1) OF
                ID_CONTEXTNEW:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                               WM_COMMAND,
                               ID_NewRecord,
                               0);
                END;
                ID_CONTEXTDEL:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                               WM_COMMAND,
                               ID_DeleteRecord,
                               0);
                END;
                ID_CONTEXTSORTBYICON:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                               WM_COMMAND,
                               ID_SORTBYICON,
                               0);
                END;
                ID_CONTEXTSORTBYDESC:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_SORTBYDESC,
                                0);
                END;
                ID_CONTEXTSORTBYUSER:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_SORTBYUSER,
                                0);
                END;
                ID_CONTEXTSORTBYURL:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_SORTBYURL,
                                0);
                END;
                ID_CONTEXTSORTBYSN:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_SORTBYSN,
                                0);
                END;
                ID_CONTEXTSORTBYUPDATE:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_SORTBYUPDATE,
                                0);
                END;
                ID_CONTEXTCOPYPASS:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_COPYPASS,
                                0);
                END;
                ID_CONTEXTCOPYUSR:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_COPYUSR,
                                0);
                END;
                ID_CONTEXTCOPYSERIAL:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_COPYSERIAL,
                                0);
                END;
                ID_CONTEXTCOPYMEMO:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_COPYMEMO,
                                0);
                END;
                ID_CONTEXTCOPYURL:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_COPYURL,
                                0);
                END;
                ID_ContextCopy .. ID_ContextCopy+99:BEGIN
                    CurCntr:=KrPageMan.GetCurCntr;
                    pRow:=
                      pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                                          CM_QueryRecordEmphasis,
                                          CMA_FIRST,
                                          MPFROMSHORT(CRA_SELECTED) ));

                    k:=SHORT1FROMMP(mp1)-ID_ContextCopy;
                    CurCntr:=ContainerClass(KrPageMan.ContainerList[k]);
                    IF CurCntr.isColum =FALSE THEN
                        CurCntr.SetColum;
                    CurCntr.CopyRecord(pRow);
                    WinSendMsg(CurCntr.GetHWnd,CM_INVALIDATERECORD,0,0);
                    KrPageMan.DataDoc.SetModify;
                END;
                ID_ContextMove .. ID_ContextMove+99:BEGIN
                    CurCntr:=KrPageMan.GetCurCntr;
                    pRow:=
                      pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                                          CM_QueryRecordEmphasis,
                                          CMA_FIRST,
                                          MPFROMSHORT(CRA_SELECTED) ));

                    k:=SHORT1FROMMP(mp1)-ID_ContextMove;
                    CurCntr:=ContainerClass(KrPageMan.ContainerList[k]);
                    IF CurCntr.isColum =FALSE THEN
                        CurCntr.SetColum;
                    CurCntr.MoveRecord(pRow);
                    KrPageMan.GetCurCntr.DeleteRecord;
                    WinSendMsg(CurCntr.GetHWnd,CM_INVALIDATERECORD,0,0);
                    KrPageMan.DataDoc.SetModify;
                END;
                ID_CONTEXTCONF:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                               WM_COMMAND,
                               ID_ConfRecord,
                               0);
                END;
                IDB_PageConf:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                               WM_COMMAND,
                               IDB_PageConf,
                               0);
                END;
            END;
        END;(**WM_COMMAND**)
        ELSE BEGIN
            IF pWCtlData<>NIL THEN
                result:=pWCtlData^.pOldProc(Window, msg, mp1, mp2)
            ELSE
                result:=WinDefWindowProc(Window, msg, mp1, mp2);
        END;
    END;(**case msg**)
END;


VAR
    Anchor   :HAB;
    mq       :HMQ;
    msg      :QMSG;
    swp      :os2pmapi.SWP;
    hwndNB,hwndFrame:hwnd;
    Node:TDOMNode;
    i:INTEGER;
    ArgSt:string;
BEGIN
    ArgSt:='';
    IF ParamCount>0 THEN ArgSt:=ParamStr(1);

    Anchor:=WinInitialize(0);
    IF Anchor=0 THEN HALT(-1);

    mq:=WinCreateMsgQueue(Anchor, 0);

    IF mq=0 THEN BEGIN
        WinTerminate(Anchor);
        HALT(-2);
    END;

    ToolkitInit(Anchor);

    WinQueryWindowPos(HWND_DESKTOP, swp);

    hwndFrame:=CreateCell(mainFrame, HWND_DESKTOP, 0);

    IF hwndFrame<>0 THEN BEGIN
        hwndNb:=CellWindowFromID(hwndFrame, ID_NOTEBOOK);
        KrPageMan:=KrPageManegerClass.Create(hwndNB);
        KrPageMan.SetAnchor(Anchor);
        KrPageMan.hwndTB:=CreateToolbar(hwndFrame,mainTb);
        KrPageMan.LoadMsg;
        KrPageMan.FrameWindow:=hwndFrame;
        KrPageMan.CreateBlankPage(nbClient);


        DeleteMenu( WinWindowFromID(hwndFrame,FID_MENU),
                    ID_MoveRecord,
                    MoveToIndex);
        DeleteMenu( WinWindowFromID(hwndFrame,FID_MENU),
                    ID_CopyRecord,
                    CopyToIndex);
        xPos:=(swp.x+swp.cx div 8) ;
        yPos:=(swp.y+swp.cy div 8) ;
        xWidth:=(swp.cx div 4) *3 ;
        yHeight:=(swp.cy div 4) *3;
        ReadCfg;
        IF KrPageMan.GetRecentCount>0 THEN BEGIN
            DeleteMenu(WinWindowFromID(hwndFrame,FID_MENU),
                       ID_Recent,
                       ID_Recent0);
            FOR i:=1 TO KrPageMan.GetRecentCount DO BEGIN
                InsertSubMenu(WinWindowFromID(hwndFrame,FID_MENU),
                           ID_Recent,
                           ID_Recent0+i,
                           KrPageMan.GetRecent(i));
            END;
        END;
        WinSetWindowPos(hwndFrame,
                        NULLHANDLE,
                        xPos,yPos,xWidth,yHeight,
                        SWP_ACTIVATE OR SWP_MOVE OR SWP_SIZE OR SWP_SHOW);
        KrPageMan.DataDoc.isUseCrypt:=FALSE;
        IF (ArgSt<>'')AND (FileExists(ArgSt)) THEN BEGIN
            SetFileCrypt(ArgSt);
            KrPageMan.LoadData(ArgSt,nbClient) ;
        END;
        MakeLockButtonState;
        ActiveSubMenu(KrPageMan.FrameWindow,
                      ID_OPTIONMENU,
                      ID_USESTATUS,
                      ID_USEYES,
                      KrPageMan.isUseStatus);
        ActiveSubMenu(KrPageMan.FrameWindow,
                      ID_OPTIONMENU,
                      ID_USESTATUS,
                      ID_USENO,
                      NOT(KrPageMan.isUseStatus));
        KrPageMan.FlushPageMenu;
        KrPageMan.CreatePageMenu;

        // -------------------------------
        WHILE WinGetMsg(Anchor,msg,0,0,0) DO WinDispatchMsg(Anchor,msg);
        // -------------------------------
    END;
    WinDestroyWindow(hwndFrame);
    WinDestroyMsgQueue(mq);
    WinTerminate(Anchor);
END.

